
_WriteSSD:
;portmon.c,4 :: 		void WriteSSD(char value) {
;portmon.c,6 :: 		P3_0_bit = 0;   //clk
	CLR C
	MOV A, P3_0_bit+0
	MOV #224, C
	MOV P3_0_bit+0, A
;portmon.c,7 :: 		P3_1_bit = 0;   //rclk
	CLR C
	MOV A, P3_1_bit+0
	MOV #224, C
	MOV P3_1_bit+0, A
;portmon.c,8 :: 		P3_2_bit = 0;   //data
	CLR C
	MOV A, P3_2_bit+0
	MOV #224, C
	MOV P3_2_bit+0, A
;portmon.c,9 :: 		for(pos = 0; pos < 8; pos++) {
	MOV WriteSSD_pos_L0+0, #0
L_WriteSSD0:
	CLR C
	MOV A, WriteSSD_pos_L0+0
	SUBB A, #8
	JNC L_WriteSSD1
;portmon.c,10 :: 		Delay_us(5);
	NOP
;portmon.c,11 :: 		P3_2_bit = (value >> pos) & 1;
	MOV R1, WriteSSD_pos_L0+0
	MOV A, FARG_WriteSSD_value+0
	INC R1
	SJMP L__WriteSSD7
L__WriteSSD8:
	CLR C
	RRC A
L__WriteSSD7:
	DJNZ R1, L__WriteSSD8
	MOV R0, A
	ANL 0, #1
	MOV A, R0
	RRC A
	MOV A, P3_2_bit+0
	MOV #224, C
	MOV P3_2_bit+0, A
;portmon.c,12 :: 		Delay_us(5);
	NOP
;portmon.c,13 :: 		P3_0_bit = 1;
	SETB C
	MOV A, P3_0_bit+0
	MOV #224, C
	MOV P3_0_bit+0, A
;portmon.c,14 :: 		Delay_us(10);
	NOP
	NOP
	NOP
;portmon.c,15 :: 		P3_0_bit = 0;
	CLR C
	MOV A, P3_0_bit+0
	MOV #224, C
	MOV P3_0_bit+0, A
;portmon.c,9 :: 		for(pos = 0; pos < 8; pos++) {
	INC WriteSSD_pos_L0+0
;portmon.c,16 :: 		}
	SJMP L_WriteSSD0
L_WriteSSD1:
;portmon.c,17 :: 		P3_1_bit = 1;
	SETB C
	MOV A, P3_1_bit+0
	MOV #224, C
	MOV P3_1_bit+0, A
;portmon.c,18 :: 		Delay_us(10);
	NOP
	NOP
	NOP
;portmon.c,19 :: 		P3_1_bit = 0;
	CLR C
	MOV A, P3_1_bit+0
	MOV #224, C
	MOV P3_1_bit+0, A
;portmon.c,20 :: 		}
	RET
; end of _WriteSSD

_ShowNumber:
;portmon.c,22 :: 		void ShowNumber(char num) {
;portmon.c,23 :: 		WriteSSD(ssd_table[(num & 15)]);
	MOV A, FARG_ShowNumber_num+0
	ANL A, #15
	MOV R0, A
	MOV A, #_ssd_table+0
	ADD A, R0
	MOV R0, A
	MOV FARG_WriteSSD_value+0, @R0
	LCALL _WriteSSD+0
;portmon.c,24 :: 		P3_3_bit = 1;
	SETB C
	MOV A, P3_3_bit+0
	MOV #224, C
	MOV P3_3_bit+0, A
;portmon.c,25 :: 		Delay_ms(5);
	MOV R6, 3
	MOV R7, 229
	DJNZ R7, 
	DJNZ R6, 
;portmon.c,26 :: 		P3_3_bit = 0;
	CLR C
	MOV A, P3_3_bit+0
	MOV #224, C
	MOV P3_3_bit+0, A
;portmon.c,27 :: 		Delay_us(50);
	MOV R7, 7
	DJNZ R7, 
;portmon.c,28 :: 		WriteSSD(ssd_table[(num >> 4)]);
	MOV R1, #4
	MOV A, FARG_ShowNumber_num+0
	INC R1
	SJMP L__ShowNumber9
L__ShowNumber10:
	CLR C
	RRC A
L__ShowNumber9:
	DJNZ R1, L__ShowNumber10
	MOV R0, A
	MOV A, #_ssd_table+0
	ADD A, R0
	MOV R0, A
	MOV FARG_WriteSSD_value+0, @R0
	LCALL _WriteSSD+0
;portmon.c,29 :: 		P3_4_bit = 1;
	SETB C
	MOV A, P3_4_bit+0
	MOV #224, C
	MOV P3_4_bit+0, A
;portmon.c,30 :: 		Delay_ms(5);
	MOV R6, 3
	MOV R7, 229
	DJNZ R7, 
	DJNZ R6, 
;portmon.c,31 :: 		P3_4_bit = 0;
	CLR C
	MOV A, P3_4_bit+0
	MOV #224, C
	MOV P3_4_bit+0, A
;portmon.c,32 :: 		Delay_us(50);
	MOV R7, 7
	DJNZ R7, 
;portmon.c,33 :: 		}
	RET
; end of _ShowNumber

_main:
	MOV SP+0, #128
;portmon.c,35 :: 		void main() {
;portmon.c,36 :: 		ACSR = 0;
	MOV ACSR+0, #0
;portmon.c,37 :: 		SCON = 0;
	MOV SCON+0, #0
;portmon.c,38 :: 		P3 = 0;
	MOV P3+0, #0
;portmon.c,39 :: 		P1 = 255;
	MOV P1+0, #255
;portmon.c,40 :: 		linput = 0;
	MOV _linput+0, #0
;portmon.c,41 :: 		input_main = 0;
	MOV _input_main+0, #0
;portmon.c,42 :: 		beep_counter = 4;
	MOV _beep_counter+0, #4
;portmon.c,44 :: 		while(1) {
L_main3:
;portmon.c,45 :: 		input_main = P1;
	MOV _input_main+0, ___CC2D+0
;portmon.c,46 :: 		ShowNumber(input_main);
	MOV FARG_ShowNumber_num+0, _input_main+0
	LCALL _ShowNumber+0
;portmon.c,47 :: 		if(input_main != linput)
	MOV A, _input_main+0
	XRL A, _linput+0
	JZ L_main5
;portmon.c,48 :: 		beep_counter = 0;
	MOV _beep_counter+0, #0
L_main5:
;portmon.c,49 :: 		P3_5_bit = 0;
	CLR C
	MOV A, P3_5_bit+0
	MOV #224, C
	MOV P3_5_bit+0, A
;portmon.c,50 :: 		if(beep_counter < 4) {
	CLR C
	MOV A, _beep_counter+0
	SUBB A, #4
	JNC L_main6
;portmon.c,51 :: 		P3_5_bit = 1;
	SETB C
	MOV A, P3_5_bit+0
	MOV #224, C
	MOV P3_5_bit+0, A
;portmon.c,52 :: 		beep_counter++;
	INC _beep_counter+0
;portmon.c,53 :: 		}
L_main6:
;portmon.c,54 :: 		linput = input_main;
	MOV _linput+0, _input_main+0
;portmon.c,55 :: 		}
	SJMP L_main3
;portmon.c,57 :: 		}
	SJMP #254
; end of _main
